package filter;

import java.io.IOException;
import java.sql.Connection;
import java.sql.SQLException;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.sql.DataSource;

import org.apache.commons.dbutils.DbUtils;

public class BaseFilter implements Filter {
	private DataSource ds = null;

	public void init(FilterConfig arg0) throws ServletException {
		//DataSource̎擾
		try {
			Context ctx;
			ctx = new InitialContext();
			Context env = (Context)ctx.lookup("java:comp/env");
			ds = (DataSource)env.lookup("jdbc/kenkyu");
		} catch (Exception e){
			e.printStackTrace();
			throw new ServletException(e);
		}
	}

	public void doFilter(ServletRequest request, ServletResponse response,
			FilterChain chain) throws IOException, ServletException {
		
		request.setCharacterEncoding("Windows-31J");
		
		Connection con = null;
		try {
			try {
				//DBڑ
				con = ds.getConnection();
				con.setAutoCommit(false);
				request.setAttribute("jdbc.connection", con);

				chain.doFilter(request, response);

				con.commit();
			} catch (SQLException e){
				DbUtils.rollback(con);
				throw e;
			} finally {
				DbUtils.closeQuietly(con);
			}
		} catch (Exception e){
			throw new ServletException(e);
		}
		
	}
	public void destroy() {
	}

}
